:main
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: GLOBAL/CONSTANT SETTINGS
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:: GLOBAL constants and variables go up here
cls
setlocal
color F1
:: LOCAL constants and variables go below the 'setlocal' statement.
:: Set Working Directory to variable
set _cd=%cd%
::  NewPatch installed variable. If a new patch is installed, this variable is set to 1
set _npatch=0
:: Is this an internal version of BZ?
set _isinternal=0
:: New bz_options function uses this variable to determine menu choices
set _opt=
:: New variable (v4.2.6) for setting WGET Retries.
set _retries=3
:: This actually sets up the wg constant/variable below.
set wg=wget -N -t %_retries%
:: set local variables
set bzver=5.0.0&set build=081210&set buildstat=FINAL
:: Set the build date of the files included, so that the new bz_upd code functions properly.
set mdy=/D:12-10-2008 
set bzroot="BZ"&set util="BZ\Utils"&set mal="BZ\Malware"&set app="BZ\Apps"&set upd="updates"
:: set logger path & :: set logfile to the entered value, set format to <date> <time>: <message>LINEFEED
set log=logger.exe&&set ncr=nocrlf.exe&&set LOGGER_OPTS="logfile=bzlog.log;FORMAT="$D $T: $M$_""
@echo off
if exist bzlog.log %log%|%ncr%
%log% [BootZilla v%bzver%-%build% %buildstat%] Build Log|%ncr%
%log% MDY Value: %mdy%|%ncr%
%log% Using updates script: %build%.cmd|%ncr%
if "%_isinternal%"=="1" %log% THIS IS AN INTERNAL BUILD OF BZ!|%ncr%
%log% Working Directory: %_cd%|%ncr%
cls
:bz_menu
:: If this is a new patch, we should pull the new patch info so we're going to force a re-read of the main function
:: This will reset all the variables to their default settings. This should alleviate any patching problems.
if %_npatch%=="1" goto main
:: Set local variable that needs to be re-read following any setting changes
set wg=wget -N -t %_retries%
:: Loads the BootZilla Menu
cls
set _task=
set _bootcd=
cls
echo ***********************************
echo  BootZilla v%bzver%-%build% %buildstat%
if "%_isinternal%"=="1" echo  INTERNAL BUILD
echo  www.bootzilla.org                                
echo ***********************************
echo [O] BootZilla Update Options
echo [S] SFX Updater [Advanced Users]
echo [F] Cleanly update your build of BZ.
echo                                     Download Size
echo                                     -------------
echo [1] Quick Build BootZilla [Do this First]    60MB
echo [2] Update BootZilla                        ~20MB
echo [3] Quick-Update BootZilla                   ~5MB
echo -                       
echo [4] Build BootZilla Boot CD                  12MB
echo -                                  
echo [5] Clean out Old Programs       
echo [8] Slow-Build BootZilla                    105MB
echo [9] Read Changelog                  -------------
echo -
echo                               Press ENTER to exit                                         
set /p _task=What would you like to do:

if "%_task%" == "" goto end
if "%_task%" == "1" goto bz_qbuild
if "%_task%" == "2" goto bz_upd
if "%_task%" == "3" goto bz_qupd
if "%_task%" == "4" set _bootcd=1&&goto bz_boot
if "%_task%" == "5" goto bz_finisher
if "%_task%" == "8" goto bz_cdir
if "%_task%" == "9" goto bz_readlog
if "%_task%" == "O" goto bz_options
if "%_task%" == "S" goto bz_advtools
if "%_task%" == "F" goto bz_cleanupd

goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: OPTIONS
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_options
echo.
echo [P] Setup Proxy Server^:    %http_proxy%
echo [R] Reset Proxy Server Setting
echo [T] Set number of Retries to download files [%_retries%]
echo.
set /p _opt=What would you like to do: 

if "%_opt%" == "" goto bz_menu
if "%_opt%" == "P" goto bz_proxy
if "%_opt%" == "T" goto bz_retries
if "%_opt%" == "R" set http_proxy=&&set set_pxy=""&&%log% Reset Proxy Server to null values|%ncr%&&goto bz_menu

goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: WGET SETTINGS
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_retries
echo.
set /p _retries=How many retries should WGET execute before skipping a file download? 

echo.
goto bz_menu

:bz_proxy
:: Set wget options in here.
:: http_proxy is a variable that WGET looks for, it is not defined outside of this function because it's not a local variable.
echo Proxy Settings
echo.
set /p http_proxy=Enter your proxy server in http://username:password@xyz.com:8080/ Format:  
  

echo.&&%log% Proxy Server: %http_proxy%|%ncr%
echo.
echo Proxy settings set. Re-starting script.
set_pxy="--proxy=on"
goto bz_menu

:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: DIRECTORY CREATION
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_cdir
%log% User chose to build BootZilla v%bzver%-%build%|%ncr%
call createdirs.cmd
:: Now we call the Sanitize script, which will delete any old files.
echo Sanitizing BZ Sub-Directory...
start "" /wait sanitize.cmd
set LOGGER_OPTS="logfile=bzlog.log;FORMAT="$D $T: $M$_""
goto bz_build2

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: SLOW-BUILD BootZilla
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_build2
:: Creates local cache of BootZilla files.
:: Check our dependencies first...
if not exist sanitize.cmd set sm=1&&goto bz_fileerror
if not exist wget.exe set wm=1&&goto bz_error
set LOGGER_OPTS="logfile=bzlog.log;FORMAT="$D $T: $M$_""
%log% Downloading BootZilla files...|%ncr%
echo.
echo.
echo *****************************
echo BootZilla v%bzver%-%build% %buildstat%
echo www.bootzilla.org
echo by jimmsta
echo *****************************
echo.
echo. Download Process Commencing. This will take a while.
:: If 7z.exe is missing, 7z.dll is probably missing too, so we download the latest versions from our repository.
:: Also, if we're building from scratch, we should really force an update check of the 7zip binaries.
:: if not exist 7z.exe 
%wg% http://www.bootzilla.org/43x/7z/7z.exe&&%wg% http://www.bootzilla.org/43x/7z/7z.dll&&%log% Downloaded 7zip|%ncr%
:: if exist %u%\sysinternals\autoruns.exe del /f/s/q %u%\sysinternals\*.*&&%log% Removed old sysinternals tools|%ncr%
start "" /wait bz_utils.cmd
:: echo %errorlevel%
%log% Utils Downloaded|%ncr%
start "" /wait bz_apps.cmd
:: echo %errorlevel%
%log% Apps Downloaded|%ncr%
start "" /wait bz_mal.cmd
:: echo %errorlevel%
%log% ANTI-Malware Tools Downloaded|%ncr%
:: wget -N -i qmal.urls -P BZ/Malware/
:: %log% ANTI-Malware Tools Fully Updated|%ncr%
%log% Entering cleanup stage...|%ncr%
echo Performing Cleanup...
start "" /wait decompress.cmd
goto bz_finisher

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: QUICK-BUILD BootZilla
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_qbuild
:: downloads bz5base.zip, decompresses snapshot and performs the CLEANUP stage of the script
if not exist sanitize.cmd goto bz_fileerror
if not exist wget.exe goto bz_error
if not exist 7z.exe %wg% http://www.bootzilla.org/43x/7z/7z.exe&&%wg% http://www.bootzilla.org/43x/7z/7z.dll&&%log% Downloaded 7zip|%ncr%
if not exist 7z.exe goto bz_error
%log% User chose to ^do a QUICK Build.|%ncr%
%log% Downloading latest snapshot...|%ncr%
:: Grabs the latest bz5base.zip file, generated by bz5 mini.
%wg% http://www.bootzilla.org/5x/f/bz5base.zip
:: echo %errorlevel%
:: if %errorlevel% == 0 echo Download Failed.
if not exist bz5base.zip %log% bz5base.zip is missing. cannot continue.|%ncr%&&goto bz_error
7z.exe -y x bz5base.zip
copy BZ.ico BZ/
echo.
%log% Entering cleanup stage...|%ncr%
echo Performing Cleanup...
start "" /wait decompress.cmd
goto bz_finisher

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: UPDATE BootZilla [Latest.7z]
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_upd
%log% User chose to update BootZilla|%ncr%
:: version 5.0 introduces update staging and deployment
:: First, we grab the latest 7z.exe and 7z.dll file like the old code.
if not exist 7z.exe %wg% http://www.bootzilla.org/43x/7z/7z.exe&&%wg% http://www.bootzilla.org/43x/7z/7z.dll&&%log% Downloaded 7zip|%ncr%
:: Next, we grab the latest.7z file, and decompress it into BZ\updates\staging\
:: New (12/10/08) URL for all v5x+ builds (bootzilla.org/5x/p/latest.7z)
%wg% http://www.bootzilla.org/5x/p/latest.7z
7z.exe -y x latest.7z -o%upd%\staging\
:: Now we move the contents of BZ\updates\stating into the BZ folder, overwriting older files only. 
:: The MDY value is defined in the early stage of the script, and is setup to be whatever the build number is, unless otherwise stated.
xcopy %mdy% /S /Y %upd%\staging\*.* %CD%
:: And now, we make sure that the staging folder is clear of any remaining files
if exist %upd%\staging\BZUpdate.cmd del /F /S /Q %upd%\staging\*.*
:: Now we tell the user to select Option 1 at the re-start of the script.
echo.
echo Select Option 1 once script re-starts.
echo.
pause
:: %log% BootZilla v%bzver%-%build% Installed. Now restarting script...|%ncr%
set _npatch=1&&goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: QUICK-UPDATE BootZilla [bz_mal.cmd]
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_qupd
:: Downloads a few updated Malware removal utilities.
%log% Quick Updating BootZilla...|%ncr%
start "" /wait bz_mal.cmd
goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: SETUP DEVTOOLS.7z
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_advtools
echo.
if not exist 7z.exe wget -N http://www.bootzilla.org/43x/7z/7z.exe&&wget -N http://www.bootzilla.org/43x/7z/7z.dll&&%log% Downloaded 7zip|%ncr%
if not exist 7z.exe goto bz_error
:: First we will grab the latest devtools and extract the archive into the current directory
:: we will then execute devsetup.cmd to set up required tools and execute the sfxpatcher.
%wg% http://www.bootzilla.org/43x/dev/devtools.7z
7z.exe -y e devtools.7z -o %upd%\staging
xcopy %mdy% /S /Y %upd%\staging\*.* %CD%
start "" /wait devsetup.cmd
:: run sfxpatch.cmd now
cmd.exe /k sfxpatch2.cmd
if exist %upd%\staging\devsetup.cmd del /F /S /Q %upd%\staging\*.*
goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: UPDATES CLEANUP [previously bz_forceupd]
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_cleanupd
:: CleanUpdate - Updates the local build of BootZilla with all the latest updates.
:: Cleans out all old files, and is custom-tailored to the version of BZ that currently resides on the machine.
:: If the build is older than 080701, we set the build variable passed to the script as the 080701 build number.
if %build% LEQ "080701" set build=080701
call %upd%\%build%.cmd
:: Then we call the commonupd.cmd file, which contains common files that have been left around in every build.
:: This file also cleans up older index.html files and various other interface-related files.
call %upd%\Commonupd.cmd
goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: BUILD BOOTCD
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_boot
%log% User chose to build BootCD...|%ncr%
start "" /wait sanitize.cmd 
cls
if not exist 7z.exe %wg% http://www.bootzilla.org/43x/7z/7z.exe&&%wg% http://www.bootzilla.org/43x/7z/7z.dll&&%log% Downloaded 7zip|%ncr%
if not exist 7z.exe goto bz_error
:: First, we download and extract the latest release of CGT to the CGT subdirectory.
:: Secondly, we download any available patches for CGT and unzip them
%wg% http://www.bhtproject.org/library/BHT4x/CGTBoot.7z
7z.exe -y x CGTBoot.7z -oCGT -aoa -r
echo.
:: Check to see if there's any new patches for CGT, and download them.
wget -N http://www.bhtproject.org/library/BHT4x/CGTpatch.7z
7z.exe -y x CGTpatch.7z -oCGT -aoa -r
echo.
:: We actually delete any older BZ directories in the CGT directory BEFORE copying BZ to the CGT directory.
echo Copying BootZilla to CGT directory.
rmdir /Q /S "CGT\BZ\"
MD "CGT\BZ"
:: The following isolinux.bin bit is old, and might be obsolete <OBSOLETE?>
xcopy /E /Y /H /I "CGT/isolinux/isolinux.bin" isolinux.bin
xcopy /E /Y /H /I BZ "CGT/BZ"
echo.
mkisofs.exe -N -J -joliet-long -D -V "BootZilla_%build%" -o ./BZ-%build%.iso -b "isolinux.bin" -no-emul-boot -boot-load-size 4 -boot-info-table CGT/
%log% BootCD ISO has been created.|%ncr%
%log% ISO Name: BZ-%build%.iso|%ncr%
cls
echo.
echo.
echo BZ-%build%.iso has been created in %_cd%.
echo.
echo You can burn the ISO file with the included ImgBurn software.
echo Read the readme file for more information.
echo.
echo.
pause
goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: DISPLAY CHANGELOG
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_readlog
:: Useless function. If we include notepad2 or something, we should force changelog to open using that viewer.
echo.
notepad.exe changelog.txt
goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: UPDATE AND INSTALL ADDONS
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_addonpacks
:: Scan for any additional bz_ao*.cmd files, not included with the default configuration
:: Update any bz addons.
:: goto menu
goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: FINISH BUILD PROCESS
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_finisher
:: This function is not necessary. Move it back into bz_build or something.
:: Removes unneeded files, cleans up the target directory and readies it for distribution.
echo.
%log% Sanitization stage...|%ncr%
call %upd%\%build%.cmd
start "" /wait sanitize.cmd
echo.
set _task=
:: Reset the whole script to the beginning.
goto main

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: ERROR MESSAGES
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:bz_fileerror
echo.
if sm=1 echo sanitize.cmd is missing. Please press enter.&&%log% sanitize.cmd is missing.|%ncr%
:: if sanitize is missing, we'll try to download the latest.7z and extract it. 
echo You are missing crucial files for the script to continue. 
echo I will try re-downloading the latest release, in hopes of fixing the problem for you
echo.
pause
%log% Error occured ^in dependencies. Re-downloading latest update.|%ncr%
goto bz_upd

:bz_error
echo.
echo Some sort of error occured. Check bzlog.log for more details.
echo.
if wm=1 echo Wget.exe is missing. Please go to bootzilla.org and download the latest release&&%log% wget.exe is missing.|%ncr%
pause
%log% Oh god how did this get here I'm ^not very good with computers|%ncr%
%log% Something is broken. Possibly a missing file on the server or something died.|%ncr%
%log% Unknown Error Occured. Please send this log to: jimmsta^@gmail.^com|%ncr%
echo.
goto bz_menu

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: END SCRIPT
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:end
echo ============
:: This logs that the user is exiting, and it resets the console colors to their defaults. Then it kills all the local variables and exits out of the session.
%log% User ^exit|%ncr%
color 07
endlocal
exit