@echo off
setlocal
:: BuildPackage.cmd
:: Builds a set of tools and BootZilla packages,
:: version and build stated below in pkgver and buildv variables.
:: by jimmsta
set pkgver=1.25
set buildv=081210
:: release variable is the command line to build a zip package of necessary bootzilla files
:: set release=7z.exe a -tzip -md=32m -mfb=64 "release.zip" 7zsfxmkr31.cmd  sfxpatch2.cmd index.html bzstyles.css bz.ico mkisofs.exe logger.exe nocrlf.exe wget.exe license.txt isolinux.bin Readme.txt decompress.cmd Malware.urls Utils.urls Apps.urls changelog.txt BZUpdate.cmd sanitize.cmd BuildPackage.cmd
:: frelease variable is the command line to build a FULL Release package <includes 7zip files>
set frelease=7z.exe a -tzip -md=32m -mfb=64 "bz5base.zip" qdefrag.cmd jkdefragcmd.exe msistub.exe devsetup.cmd 7zS.sfx selector.cmd createdirs.cmd bzmultitool.cmd msvcr71.dll wait.cmd bz_mal.cmd bz_utils.cmd bz_apps.cmd 7z.exe 7z.dll 7zsfxmkr31.cmd  sfxpatch2.cmd index.html bzstyles.css bz.ico mkisofs.exe logger.exe nocrlf.exe wget.exe license.txt isolinux.bin Readme.txt decompress.cmd changelog.txt BZUpdate.cmd sanitize.cmd BuildPackage.cmd updates\ updates\*
:: patch variable is the command line to build a 7zip latest.7z package of necessary bootzilla files
set patch=7z.exe a -t7z -m0=LZMA -mmt=on -mx9 -md=64m -mfb=64 -ms=on "latest.7z" qdefrag.cmd jkdefragcmd.exe createdirs.cmd bzmultitool.cmd msvcr71.dll wait.cmd bz_mal.cmd bz_utils.cmd bz_apps.cmd logger.exe nocrlf.exe index.html bzstyles.css bz.ico Readme.txt decompress.cmd sanitize.cmd BZUpdate.cmd changelog.txt BuildPackage.cmd updates\ updates\*
:: devtools variable is the command line to build a 7zip compressed devtools.7z package of necessary development bootzilla files
:: Devtools will be merged into frelease for v5 final.
set devtools=7z.exe a -t7z -m0=LZMA -mmt=on -mx9 -md=64m -mfb=64 -ms=on "devtools.7z" msistub.exe selector.cmd createdirs.cmd bzmultitool.cmd msvcr71.dll wait.cmd 7zsfxmkr31.cmd sfxpatch2.cmd BuildPackage.cmd devsetup.cmd 7z.exe 7z.dll 7zS.sfx mkisofs.exe
cls
color 71
echo.
echo *****************************
echo * BootZilla package builder *
echo * v%pkgver%-%buildv%        *
echo * for BootZilla v5.0        *
echo *****************************
echo.
echo Building Packages...
echo.
if exist latest.7z copy latest.7z latest_old.7z
if exist bz41*.zip copy bz41*b*.zip bz41x_old.zip
if exist bz42*.zip copy bz42*.zip bz42_old.zip
if exist bz43*.zip copy bz43.zip bz43_old.zip
::%release%
%patch%
pause
%devtools%
pause
%frelease%
pause
echo Packages have been built.
endlocal
exit